//----------------------------------------------------------------------------------------
// Author: Stanislav.Shilo (shilo.stanislav.dmitrievich@gmail.com, skype: stanislav.shilo)
//----------------------------------------------------------------------------------------
var similar_sites_pop_up = {
	url : '',
	init : function(){
		var newUrl = similar_sites_pop_up.getCurrentURL();
		if ( similar_sites_pop_up.url == newUrl )
			return;
		similar_sites_pop_up.url = newUrl;
		$('#headerSimilarSites_title').text(  similar_sites_pop_up.get_hostname(similar_sites_pop_up.url) );
		similar_sites_pop_up.getSimiliarSites(similar_sites_pop_up.url);

	},
	
	getSimiliarSites : function(url)
	{
		$('#loading_div').show();
		$('.InnerContainer').hide();
		
		var s=200;
		try{s=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("").getCharPref("similarsites.src");}
		catch(e){}
		
		var suffix = "1";
		if ( s == "200")
			suffix = "";
		var similarQuery = "http://www.thetrafficstat.net/related?s="+s+suffix+"&md=18&q=" +   encodeURIComponent(similar_sites_pop_up.get_hostname(url)) ; 
		$.ajax({
			type: "GET",
			url: similarQuery,
			dataType : 'xml',
			success: function (result) {
				$('#loading_div').hide();
				$('.InnerContainer').show();
				similar_sites_pop_up.processSimiliarXML(result);
			},
			error: function () {
		 
			}
		});

	},
	processSimiliarXML : function(xml)
	{
		var cnt = 0;
		try 
		{
			var status = $(xml).find("status").text();
			if (status == 0) 
			{
				// Enumerate similiar sites and create a 'button' for them.
				$(xml).find("site").each(function () 
				{
					var name = $(this).find("title").text();
					var url = $(this).find("url").text();
					var icon = $(this).find("icon").text();
					var image = $(this).find("image").text();
					var description = $(this).find("description").text();
					var title = $(this).find("title").text();
					url = 'http://' + url;
					similar_sites_pop_up.addSiteButton(name, url, icon, image, description);
					cnt = cnt+1;
				});
					   
				similar_sites_pop_up.processSimiliar();  
			}
			else if( (status != 0) || ( cnt == 0) )
			{
			try{
				var d = $("<div />");
				var host_span = $("<span />").addClass("site").append(similar_sites_pop_up.get_hostname(similar_sites_pop_up.getCurrentURL()));
				var unable_msg = $("<p />").addClass("no-results-para").append("Unable to locate results for ").append(host_span);
				var try_later = $("<p />").addClass("no-results-para").append("Please try again later");
				var img_item = $("<img />",{src:'chrome://similarsites/skin/ss-large.png'}).addClass("no-results-logo");
				var img_link = $("<a />").append(img_item);
				var error_img = $("<p />",{id:'error-img'}).addClass("no-results-para").append(img_link).click(function(){   var cur_url = "http://www.similarsites.com/";    similar_sites_pop_up.loadUrlInNewTab(cur_url);   });;
				d.addClass("container").css("background-color","white").css("height","100%").append(unable_msg).append(try_later).append(error_img);
				$('.InnerContainer').append(d); 
			
			}catch (e){}

			
			}
		}
		catch (ex) 
		{}

	},
	addSiteButton : function(name, url, icon, image, description) 
	{ 
		var hostUrl = similar_sites_pop_up.getHost(url);
		var button = similar_sites_pop_up.createButton(name, hostUrl, icon , image, description);
		$('.InnerContainer').append(button);
		return button;
	},
	createButton : function(name, url, icon , image, description) 
	{       
		if(name == null)         name = '';
		if(url == null)          url = '';
		if(icon == null)         icon = '';
		if(image == null)        image = '';
		if(description == null)  description = '';      
		
		var img_ThumbRT = document.createElement("img");
		img_ThumbRT.className = "ThumbRT";            
		img_ThumbRT.setAttribute('src', image);
		img_ThumbRT.setAttribute('title', description);
		img_ThumbRT.setAttribute('alt', name);
		
		
		var div_ThumbRTWrapper = document.createElement("div");
		div_ThumbRTWrapper.className = "ThumbRTWrapper";  
		div_ThumbRTWrapper.appendChild(img_ThumbRT);
		
		var div_ThumbImageWrapper = document.createElement("div");
		div_ThumbImageWrapper.className = "ThumbImageWrapper";  
		div_ThumbImageWrapper.appendChild(div_ThumbRTWrapper);
		
		var div_ThumbHeadWrapper = document.createElement("div");
		div_ThumbHeadWrapper.className = "ThumbHeadWrapper";
		div_ThumbHeadWrapper.textContent = name;
			
//		var div_ThumbDiscrWrapper = document.createElement("div");
//		div_ThumbDiscrWrapper.className = "ThumbDiscrWrapper";
//		div_ThumbDiscrWrapper.textContent = description;     
			
		var div_ThumbURLWrapper = document.createElement("div");
		div_ThumbURLWrapper.className = "ThumbURLWrapper";
		div_ThumbURLWrapper.textContent = url;
			
			
		var div_ThumbRI = document.createElement("div");
		div_ThumbRI.className = "ThumbRI";
		div_ThumbRI.appendChild(div_ThumbImageWrapper);
		div_ThumbRI.appendChild(div_ThumbHeadWrapper);
		//div_ThumbRI.appendChild(div_ThumbDiscrWrapper);
		div_ThumbRI.appendChild(div_ThumbURLWrapper);
		
		var div_ThumbRIWrapper = document.createElement("div");
		div_ThumbRIWrapper.className = "ThumbRIWrapper";
		div_ThumbRIWrapper.setAttribute('title', description);
		div_ThumbRIWrapper.appendChild(div_ThumbRI);       
		
		return div_ThumbRIWrapper;                
	},
	processSimiliar : function() 
	{    
		var s=200;
		try{s=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("").getCharPref("similarsites.src");}
		catch(e){}
		

		var site_url = $('#headerSimilarSites_title').text();    
		var title_url = site_url.replace('http://','').replace('www.','') ;
		title_url =   title_url[0].toUpperCase() + title_url.substr(1).toLowerCase() ;
		$('#headerSimilarSites_title').text(  title_url  + ' - ' + 'Similar Sites');

		$('.ThumbRIWrapper').click(function()
		{
			var cur_url = "http://www." +  $('.ThumbURLWrapper',this).text();       
			parent.hrefererDataSimSites = 'http://www.similarsites.com/site/' + $('.ThumbURLWrapper',this).text();
			similar_sites_pop_up.loadUrlInNewTab(cur_url);
		}); 

		$('.ThumbRIWrapper').mouseover(function()
		{
			$(this).addClass('ThumbHover');
			$('.thumbnail',this).css('display','block'); 
		}); 

		$('.ThumbRIWrapper').mouseout(function()
		{
			$(this).removeClass('ThumbHover');
			$('.thumbnail',this).css('display','none');
		});     
				 
		$('#moreResults_text').click(function()
		{ 
			var cur_url = "http://www.similarsites.com/search?searchURL=" + encodeURIComponent(similar_sites_pop_up.get_hostname(similar_sites_pop_up.url).replace('http://www.','')) + "&ref="+s;  
			similar_sites_pop_up.loadUrlInNewTab(cur_url);
		});  

		$('#options_text').click(function()
		{ 
			window.open("chrome://similarsites/content/options.xul", 'SimilarSites Options', 'chrome, centerscreen, modal');
		});  
		
		
		$('#moreResults_bt').click(function()
		{ 
			var cur_url = "http://www.similarsites.com/search?searchURL=" + encodeURIComponent(similar_sites_pop_up.get_hostname(similar_sites_pop_up.url).replace('http://www.','')) + "&ref="+s;  
			similar_sites_pop_up.loadUrlInNewTab(cur_url);
		}); 

		$('#footerSimilarSites a').click(function(event){	
			event.preventDefault();            
		});        

		$('#aboutUs_text').click(function()
		{                 
			var cur_url = "http://www.similarsites.com/about.aspx";
			similar_sites_pop_up.loadUrlInNewTab(cur_url);
		}); 
				
		$('#privacy_text').click(function()
		{                 
			var cur_url = "http://www.similarsites.com/privacy-policy.aspx";
			similar_sites_pop_up.loadUrlInNewTab(cur_url);
		});   

		$('#footerSimilarSites_logo_bt').click(function()
		{
			var cur_url = "http://www.similarsites.com/";
			similar_sites_pop_up.loadUrlInNewTab(cur_url);
		});   
	},	
	getHost : function (url) 
	{
		var anchor = document.createElement('a');
		anchor.href = url;
		return anchor.hostname;
	},
	get_hostname : function(url) 
	{
		var ret = '';
		try
		{
			ret = url.match(/:\/\/(.[^/]+)/)[1];
		}
		catch(e){ret = '';}
		
		return ret;
	},
	setBadge : function(text) 
	{
		chrome.browserAction.setBadgeText({ "text": text.toString() });
	},
	getCurrentURL : function()
	{
		var currentWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
		var currBrowser = currentWindow.getBrowser();
		var currURL = currBrowser.currentURI.spec;
		return currURL;
	},
	loadUrlInNewTab : function(uri) 
	{
		var currentWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
		var currBrowser = currentWindow.getBrowser();
		currBrowser.selectedTab = currBrowser.addTab( uri );    
	}	
}

similar_sites_pop_up.init();
jQuery.preloadImages = function()
{
	for(var i = 0; i<arguments.length; i++)
	{
		jQuery("<img>").attr("src", arguments[i]);
	}
};       
